diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-protection.cc ns-3.34/src/wifi/model/wifi-protection.cc
--- ns-3.33/src/wifi/model/wifi-protection.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-protection.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,114 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "wifi-protection.h"
+#include "wifi-utils.h"
+
+namespace ns3 {
+
+/*
+ * WifiProtection
+ */
+
+WifiProtection::WifiProtection (Method m)
+  : method (m),
+    protectionTime (Time::Min ())   // uninitialized
+{
+}
+
+WifiProtection::~WifiProtection ()
+{
+}
+
+
+/*
+ * WifiNoProtection
+ */
+
+WifiNoProtection::WifiNoProtection ()
+  : WifiProtection (NONE)
+{
+  protectionTime = Seconds (0);
+}
+
+std::unique_ptr<WifiProtection>
+WifiNoProtection::Copy (void) const
+{
+  return std::unique_ptr<WifiProtection> (new WifiNoProtection (*this));
+}
+
+void
+WifiNoProtection::Print (std::ostream &os) const
+{
+  os << "NONE";
+}
+
+
+/*
+ * WifiRtsCtsProtection
+ */
+
+WifiRtsCtsProtection::WifiRtsCtsProtection ()
+  : WifiProtection (RTS_CTS)
+{
+}
+
+std::unique_ptr<WifiProtection>
+WifiRtsCtsProtection::Copy (void) const
+{
+  return std::unique_ptr<WifiProtection> (new WifiRtsCtsProtection (*this));
+}
+
+void
+WifiRtsCtsProtection::Print (std::ostream &os) const
+{
+  os << "RTS_CTS";
+}
+
+
+/*
+ * WifiCtsToSelfProtection
+ */
+
+WifiCtsToSelfProtection::WifiCtsToSelfProtection ()
+  : WifiProtection (CTS_TO_SELF)
+{
+}
+
+std::unique_ptr<WifiProtection>
+WifiCtsToSelfProtection::Copy (void) const
+{
+  return std::unique_ptr<WifiProtection> (new WifiCtsToSelfProtection (*this));
+}
+
+void
+WifiCtsToSelfProtection::Print (std::ostream &os) const
+{
+  os << "CTS_TO_SELF";
+}
+
+
+std::ostream & operator << (std::ostream &os, const WifiProtection* protection)
+{
+  protection->Print (os);
+  return os;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-protection.h ns-3.34/src/wifi/model/wifi-protection.h
--- ns-3.33/src/wifi/model/wifi-protection.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-protection.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,134 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef WIFI_PROTECTION_H
+#define WIFI_PROTECTION_H
+
+#include "ns3/nstime.h"
+#include "wifi-tx-vector.h"
+#include "ctrl-headers.h"
+#include <memory>
+
+
+namespace ns3 {
+
+/**
+ * \ingroup wifi
+ *
+ * WifiProtection is an abstract base struct. Each derived struct defines a protection
+ * method and stores the information needed to perform protection according to
+ * that method.
+ */
+struct WifiProtection
+{
+  /**
+   * \enum Method
+   * \brief Available protection methods
+   */
+  enum Method
+    {
+      NONE = 0,
+      RTS_CTS,
+      CTS_TO_SELF
+    };
+
+  /**
+   * Constructor.
+   * \param m the protection method for this object
+   */
+  WifiProtection (Method m);
+  virtual ~WifiProtection ();
+
+  /**
+   * Clone this object.
+   * \return a pointer to the cloned object
+   */
+  virtual std::unique_ptr<WifiProtection> Copy (void) const = 0;
+
+  /**
+   * \brief Print the object contents.
+   * \param os output stream in which the data should be printed.
+   */
+  virtual void Print (std::ostream &os) const = 0;
+
+  const Method method;   //!< protection method
+  Time protectionTime;   //!< time required by the protection method
+};
+
+
+/**
+ * \ingroup wifi
+ *
+ * WifiNoProtection specifies that no protection method is used.
+ */
+struct WifiNoProtection : public WifiProtection
+{
+  WifiNoProtection ();
+
+  std::unique_ptr<WifiProtection> Copy (void) const override;
+  void Print (std::ostream &os) const override;
+};
+
+
+/**
+ * \ingroup wifi
+ *
+ * WifiRtsCtsProtection specifies that RTS/CTS protection method is used.
+ */
+struct WifiRtsCtsProtection : public WifiProtection
+{
+  WifiRtsCtsProtection ();
+
+  std::unique_ptr<WifiProtection> Copy (void) const override;
+  void Print (std::ostream &os) const override;
+
+  WifiTxVector rtsTxVector;       //!< RTS TXVECTOR
+  WifiTxVector ctsTxVector;       //!< CTS TXVECTOR
+};
+
+
+/**
+ * \ingroup wifi
+ *
+ * WifiCtsToSelfProtection specifies that CTS-to-self protection method is used.
+ */
+struct WifiCtsToSelfProtection : public WifiProtection
+{
+  WifiCtsToSelfProtection ();
+
+  std::unique_ptr<WifiProtection> Copy (void) const override;
+  void Print (std::ostream &os) const override;
+
+  WifiTxVector ctsTxVector;       //!< CTS TXVECTOR
+};
+
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the output stream
+ * \param protection the protection method
+ * \returns a reference to the stream
+ */
+std::ostream& operator<< (std::ostream& os, const WifiProtection* protection);
+
+} //namespace ns3
+
+#endif /* WIFI_PROTECTION_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-protection-manager.cc ns-3.34/src/wifi/model/wifi-protection-manager.cc
--- ns-3.33/src/wifi/model/wifi-protection-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-protection-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,62 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "ns3/log.h"
+#include "wifi-protection-manager.h"
+#include "regular-wifi-mac.h"
+
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("WifiProtectionManager");
+
+NS_OBJECT_ENSURE_REGISTERED (WifiProtectionManager);
+
+TypeId
+WifiProtectionManager::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::WifiProtectionManager")
+    .SetParent<Object> ()
+    .SetGroupName ("Wifi")
+  ;
+  return tid;
+}
+
+WifiProtectionManager::~WifiProtectionManager ()
+{
+  NS_LOG_FUNCTION_NOARGS ();
+}
+
+void
+WifiProtectionManager::DoDispose (void)
+{
+  NS_LOG_FUNCTION (this);
+  m_mac = 0;
+  Object::DoDispose ();
+}
+
+void
+WifiProtectionManager::SetWifiMac (Ptr<RegularWifiMac> mac)
+{
+  NS_LOG_FUNCTION (this << mac);
+  m_mac = mac;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-protection-manager.h ns-3.34/src/wifi/model/wifi-protection-manager.h
--- ns-3.33/src/wifi/model/wifi-protection-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-protection-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,94 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef WIFI_PROTECTION_MANAGER_H
+#define WIFI_PROTECTION_MANAGER_H
+
+#include "wifi-protection.h"
+#include <memory>
+#include "ns3/object.h"
+
+
+namespace ns3 {
+
+class WifiTxParameters;
+class WifiMacQueueItem;
+class RegularWifiMac;
+
+/**
+ * \ingroup wifi
+ *
+ * WifiProtectionManager is an abstract base class. Each subclass defines a logic
+ * to select the protection method for a given frame.
+ */
+class WifiProtectionManager : public Object
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  virtual ~WifiProtectionManager ();
+
+  /**
+   * Set the MAC which is using this Protection Manager
+   *
+   * \param mac a pointer to the MAC
+   */
+  void SetWifiMac (Ptr<RegularWifiMac> mac);
+
+  /**
+   * Determine the protection method to use if the given MPDU is added to the current
+   * frame. Return a null pointer if the protection method is unchanged or the new
+   * protection method otherwise.
+   *
+   * \param mpdu the MPDU to be added to the current frame
+   * \param txParams the current TX parameters for the current frame
+   * \return a null pointer if the protection method is unchanged or the new
+   *         protection method otherwise
+   */
+  virtual std::unique_ptr<WifiProtection> TryAddMpdu (Ptr<const WifiMacQueueItem> mpdu,
+                                                      const WifiTxParameters& txParams) = 0;
+
+  /**
+   * Determine the protection method to use if the given MSDU is aggregated to the
+   * current frame. Return a null pointer if the protection method is unchanged or
+   * the new protection method otherwise.
+   *
+   * \param msdu the MSDU to be aggregated to the current frame
+   * \param txParams the current TX parameters for the current frame
+   * \return a null pointer if the protection method is unchanged or the new
+   *         protection method otherwise
+   */
+  virtual std::unique_ptr<WifiProtection> TryAggregateMsdu (Ptr<const WifiMacQueueItem> msdu,
+                                                            const WifiTxParameters& txParams) = 0;
+
+protected:
+  virtual void DoDispose (void);
+
+  Ptr<RegularWifiMac> m_mac;     //!< MAC which is using this Protection Manager
+};
+
+
+
+} //namespace ns3
+
+#endif /* WIFI_PROTECTION_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-psdu.h ns-3.34/src/wifi/model/wifi-psdu.h
--- ns-3.33/src/wifi/model/wifi-psdu.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-psdu.h	2021-07-14 10:31:07.000000000 -0700
@@ -125,13 +125,14 @@
 
   /**
    * \brief Get a copy of the i-th A-MPDU subframe (includes subframe header, MPDU, and possibly padding)
+   * \param i the index in the list of A-MPDU subframes
    * \return the i-th A-MPDU subframe.
    */
   Ptr<Packet> GetAmpduSubframe (std::size_t i) const;
 
   /**
    * \brief Return the size of the i-th A-MPDU subframe.
-   *
+   * \param i the index in the list of A-MPDU subframes
    * \return the size of the i-th A-MPDU subframe.
    */
   std::size_t GetAmpduSubframeSize (std::size_t i) const;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-radio-energy-model.h ns-3.34/src/wifi/model/wifi-radio-energy-model.h
--- ns-3.33/src/wifi/model/wifi-radio-energy-model.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-radio-energy-model.h	2021-07-14 10:31:07.000000000 -0700
@@ -71,7 +71,7 @@
    *
    * Defined in ns3::WifiPhyListener
    */
-  void NotifyRxStart (Time duration);
+  void NotifyRxStart (Time duration) override;
 
   /**
    * \brief Switches the WifiRadioEnergyModel back to IDLE state.
@@ -81,7 +81,7 @@
    * Note that for the WifiRadioEnergyModel, the behavior of the function is the
    * same as NotifyRxEndError.
    */
-  void NotifyRxEndOk (void);
+  void NotifyRxEndOk (void) override;
 
   /**
    * \brief Switches the WifiRadioEnergyModel back to IDLE state.
@@ -91,7 +91,7 @@
    * Note that for the WifiRadioEnergyModel, the behavior of the function is the
    * same as NotifyRxEndOk.
    */
-  void NotifyRxEndError (void);
+  void NotifyRxEndError (void) override;
 
   /**
    * \brief Switches the WifiRadioEnergyModel to TX state and switches back to
@@ -102,41 +102,41 @@
    *
    * Defined in ns3::WifiPhyListener
    */
-  void NotifyTxStart (Time duration, double txPowerDbm);
+  void NotifyTxStart (Time duration, double txPowerDbm) override;
 
   /**
    * \param duration the expected busy duration.
    *
    * Defined in ns3::WifiPhyListener
    */
-  void NotifyMaybeCcaBusyStart (Time duration);
+  void NotifyMaybeCcaBusyStart (Time duration) override;
 
   /**
    * \param duration the expected channel switching duration.
    *
    * Defined in ns3::WifiPhyListener
    */
-  void NotifySwitchingStart (Time duration);
+  void NotifySwitchingStart (Time duration) override;
 
   /**
    * Defined in ns3::WifiPhyListener
    */
-  void NotifySleep (void);
+  void NotifySleep (void) override;
 
   /**
    * Defined in ns3::WifiPhyListener
    */
-  void NotifyOff (void);
+  void NotifyOff (void) override;
 
   /**
    * Defined in ns3::WifiPhyListener
    */
-  void NotifyWakeup (void);
+  void NotifyWakeup (void) override;
 
   /**
    * Defined in ns3::WifiPhyListener
    */
-  void NotifyOn (void);
+  void NotifyOn (void) override;
 
 
 private:
